#ifndef __CommandLine_interface__
#define __CommandLine_interface__

#include "Console.H"
#include "ConsoleObserver.H"
#include "ConsoleSystem.H"
#include "display/Display.H"
#include "InputObserver.H"
#include "InputSource.H"

#include <string.h>

class CommandLine: public InputObserver
{
protected:
  Console *_console;    
  char _input[BUFFER_SIZE];
  char *_argv[10];
  int _argc;
  int _pos;
public: 
  CommandLine(Console* con, InputSource* keys): _argc(0), _pos(0)
  {
    _console = con;
    keys->Attach(this);
    memset(_input, 0, BUFFER_SIZE);
    _argv[0] = _input;
  }

  void Message(InputSource* key, InputEvent, int);
};
#endif /* __CommandLine_interface__ */
