#ifndef __CommandObserver_interface__
#define __CommandObserver_interface__

#include "Console.H"
#include "ConsoleObserver.H"
#include "commands/ConsoleCommand.H"
#include <vector>

class CommandObserver : public ConsoleObserver
{
protected:
  typedef std::vector<ConsoleCommand*> CommandList;
  CommandList commands;
  Console* _console;
  
public:
  CommandObserver(Console* con)
  {
    assert(con);
    con->Attach(this);
    _console = con;
  }
  ~CommandObserver() {}
  void Attach(ConsoleCommand* cmd);
  void Dettach(ConsoleCommand* cmd);
  void Message(ConsoleObservable* source, ConsoleEvent, ConsoleEventInfo info);
};
#endif /* __ConsoleObserver_interface__ */
