#include "CommandLine.H"
#include <curses.h>

void CommandLine::Message(InputSource*, InputEvent event, int skey)
{
  char msg[64];
  ConsoleEventInfo eventinfo;
  
  if (event == InputEvents::Key)
  {
    eventinfo.display = msg;
    switch(skey)
    {
      case ' ':				// SPACE
      case '\t': 			// \t
        sprintf(msg, "%c", skey);
        _console->Notify(ConsoleEvents::display, eventinfo);
        if (_input[_pos-1] != '\0') {
          _input[_pos++] = '\0';
          _argv[++_argc] = _input + _pos;
        }
        break;
      case 13:			// \n
        sprintf(msg, "\n");
        _console->Notify(ConsoleEvents::display, eventinfo);

        _input[_pos] = '\0';
        eventinfo.command.argv = _argv;
        eventinfo.command.argc = ++_argc;
        _console->Notify(ConsoleEvents::command, eventinfo);

        eventinfo.display = msg;
        sprintf(msg, ">");
        _console->Notify(ConsoleEvents::display, eventinfo);

        _argc = 0;_pos  = 0;
        memset(_input, 0, BUFFER_SIZE);
        break;
      default: 
        _input[_pos++] = skey;
        sprintf(msg, "%c", skey);
        _console->Notify(ConsoleEvents::display, eventinfo);
        break;
    }
  }
}
