#include "CommandObserver.H"
#include "ConsoleSystem.H"
#include <algorithm>
#include <assert.h>

extern char buffer[BUFFER_SIZE];

void CommandObserver::Message(ConsoleObservable* source, ConsoleEvent event, ConsoleEventInfo info)
{
  if (event == ConsoleEvents::command) {
    for (CommandList::iterator where = commands.begin(); where != commands.end(); where++)
    {
      if ((*where)->IsCommand(info.command.argv[0]) == 0)
      {
        (*where)->Execute(info.command.argc, info.command.argv);
        return;
      }
    }
    sprintf(buffer, "error: command %s not found.\n", info.command.argv[0]);
    info.display = buffer;
    _console->Notify(ConsoleEvents::display, info);
  }
}

void CommandObserver::Attach(ConsoleCommand* cmd)
{
  commands.push_back(cmd);
}

void CommandObserver::Dettach(ConsoleCommand* cmd)
{
  commands.erase(find(commands.begin(),commands.end(),cmd));
}
