#include "DisplayObserver.H"
#include <assert.h>

DisplayObserver::DisplayObserver(Console* con, Display* dsp)
{
  assert(con);
  _console = con;
  _console->Attach(this);
  _dsp     = dsp;
  _dsp->Print(">");
}

void DisplayObserver::Message(ConsoleObservable* source, ConsoleEvent event, ConsoleEventInfo info)
{
  if (event == ConsoleEvents::display) {
    _dsp->Print(info.display);
  }
  _dsp->Refresh();
}
