#include "commands/CommandExit.H"
#include "commands/CommandCLEAR.H"
#include "display/CursesInputDisplay.H"
#include "Console.H"
#include "DisplayObserver.H"
#include "CommandObserver.H"
#include "CommandLine.H"


#include "fs/FSDir.H"
#include "fs/FSFile.H"

#include "fs/device/UnixDevice.H"
#include "fs/ext2/EXT2FS.H"

char buffer[BUFFER_SIZE];

// Root directory
FS *fs;
FSDir fs_root;
FSDir fs_cwd;

Console _console;
CursesInputDisplay _display;  

int main(int argc, char **argv)
{
  if ( !(argc > 1) ) {
    printf("usage: %s <path_to_image>\n",argv[0]);
    exit(1);
  } else {
    // ---------------------------------------------------------------
    // filesystem
    char *fs_path = strdup(argv[1]); //ToDebug: strdup("bin/ext2.img");
    UnixDevice dev(fs_path);
/*
    fs = new EXT2FileSystem(&dev);
    FSResult fs_result = fs->check();
    if (fs_result != FSResult::NoError) {
      sprintf(buffer, "error: %s\n", fs_result.message());
      exit(0);
    }
    fs_root = FSDir(fs);
    fs_cwd  = fs_root;
    //strcpy(cw_path, delimiter);
*/
    // -----------------------------------------------------------------
    // console & display
    CommandLine _cmdline(&_console, &_display);
    DisplayObserver _consoleO(&_console, &_display);

    // -----------------------------------------------------------------
    // commands
    CommandObserver _commandO(&_console);
    ConsoleCommand* cmd;  
    cmd = new CommandExit(&_console, "exit");
    _commandO.Attach(cmd);
    cmd = new CommandCLEAR(&_console, "clear", &_display);
    _commandO.Attach(cmd);
  
    // -----------------------------------------------------------------
    // running loop
    while(!_console.Exit() && !_console.Error()) {
      _display.GetEvent();
    }
  }
  return 1;
}
