#include "CursesDisplay.H"
#include <curses.h>

CursesDisplay::CursesDisplay() : _posX(0),_posY(0)
{
  win = initscr();
  Reset();
}

CursesDisplay::~CursesDisplay()
{
  curs_set(1);
  endwin();
}

bool CursesDisplay::Clear()
{
  erase();
  Refresh();
  return true;
}
  
bool CursesDisplay::Refresh()
{
  refresh();
  return true;
}

bool CursesDisplay::Reset()
{
  curs_set(0);
  leaveok(win,TRUE);
  return Clear();  
}

bool CursesDisplay::Print(const char* s)
{
  printw("%s",s);
  return true;
}

bool CursesDisplay::Print(int x, int y, const char* s)
{
  mvprintw(x,y,"%s",s);
  return true;
}

bool CursesDisplay::ShowSymbol(int x, int y, const char symbol)
{
  mvaddch(x,y,symbol);
  return true;
}
